'use strict';

var Minimatch = require('minimatch').Minimatch;

/**
 * Glob test
 * @param {String|Array.<String>} pattern 
 * @return {Function(String):Boolean} 
 */
var Glob = function Glob(pattern) {
    if (typeof pattern === 'string') {
        return Glob([pattern]);
    }

    var tests = pattern.map(function (p) {
        return {
            isNot: !!p.match(/^!/),
            mm: new Minimatch(p.replace(/^!/, ''))
        };
    });

    return function (path) {
        var is = false;

        tests.forEach(function (test) {
            if (test.isNot) {
                if (is && test.mm.match(path)) {
                    is = false;
                }
            } else {
                if (!is && test.mm.match(path)) {
                    is = true;
                }
            }
        });

        return is;
    };
};

module.exports = Glob;